---
title: Updating add-ons for Firefox 10
slug: Mozilla/Firefox/Releases/10/Updating_add-ons
tags:
  - Add-ons
  - Extensions
  - Firefox
  - Firefox 10
  - Gecko 10
---
<div>{{FirefoxSidebar}}</div>

<p>Although a lot of things have changed in Firefox 10 that, in theory, can cause add-on compatibility breakage, most of them are relatively obscure, so they're not very likely to affect you. This article will help guide you as you update your add-on.</p>

<h2 id="Compatible_by_default">Compatible by default</h2>

<p>The first and most important thing to note is that starting in Firefox 10, add-ons are assumed to be compatible by default. Unless you use the <a href="/en/Install_Manifests#strictCompatibility" title="en/Install_Manifests#strictCompatibility"><code>&lt;em:strictCompatibility&gt;</code></a> flag in your manifest, Firefox will no longer mark your add-on as incompatible after an upgrade to Firefox 10 or later. You can use that flag to ensure that an add-on that is likely to break will not try to run in updated copies of Firefox. It's worth noting that add-ons that have binary components will always be strictly checked for compatibility, since binary components always need to be recompiled for each major Firefox release.</p>

<div class="note"><strong>Note:</strong> You should still test your add-on on Firefox 10, even in the world of compatibility by default. Read over the rest of this article to see if there's anything you need to change.</div>

<h2 id="DOM_changes">DOM changes</h2>

<p>Some obsolete APIs have been removed from the DOM:</p>

<dl>
 <dt>{{ domxref("Node.isSameNode()") }}</dt>
 <dd>This is the removal that has the most likelihood to affect add-on developers, as it was fairly commonly used. You can now use the JavaScript <code>===</code> operator to compare nodes instead of this obsolete method. This method was made obsolete by the DOM4 specification.</dd>
 <dt>{{ domxref("text.isElementContentWhitespace") }}</dt>
 <dt>{{ domxref("text.replaceWholeText()") }}</dt>
 <dd>These APIs were rendered obsolete by the DOM4 specification.</dd>
 <dt>{{ domxref("Document.xmlEncoding") }}</dt>
 <dt>{{ domxref("Document.xmlStandalone") }}</dt>
 <dt>{{ domxref("Document.xmlVersion") }}</dt>
 <dd>All of these APIs were rendered obsolete by the DOM4 specification. They were most frequently being used to detect whether the document being displayed was HTML or XML. See the article for {{ domxref("Document.xmlVersion") }} for a recommended way to test for this going forward.</dd>
</dl>

<h2 id="XPCOM_and_interface_changes">XPCOM and interface changes</h2>

<p>The most significant change is that everywhere that previously used the <a href="/en/PRBool" title="PRBool"><code>PRBool</code></a> data type now uses the standard C++ <code>bool</code> type instead.</p>

<h3 id="Removed_interfaces">Removed interfaces</h3>

<p>The following interfaces have been removed:</p>

<dl>
 <dt>{{ interface("nsIDOMNSHTMLFrameElement") }}</dt>
 <dd>This interface has been merged into the {{ interface("nsIDOMHTMLFrameElement") }} interface.</dd>
 <dt>{{ interface("nsIDOMNSHTMLElement") }}</dt>
 <dd>This interface has been merged into {{ interface("nsIDOMHTMLElement") }}.</dd>
 <dt>{{ interface("nsIDocumentViewer") }}</dt>
 <dd>This interface has been merged into {{ interface("nsIContentViewer") }}</dd>
</dl>

<h3 id="Other_interface_changes">Other interface changes</h3>

<ul>
 <li><code>nsNavHistory</code> no longer implements the {{ interface("nsICharsetResolver") }} interface. <strong>Note that {{ interface("nsICharsetResolver") }} is no longer used and is being removed in Gecko 11.0 {{ geckoRelease("11.0") }}</strong>.</li>
 <li>The {{ interface("mozISpellCheckingEngine") }} and {{ interface("nsIEditorSpellCheck") }} interfaces have been updated to let restartless add-ons add dictionaries to the spell checker. See <a href="/En/Using_an_External_Spell-checker" title="Using an external spell checker">Using an external spell checker</a> for details (note this article has not yet been updated, but will be soon).</li>
 <li>The {{ ifattribute("nsIBrowserHistory", "lastPageVisited") }} attribute has been removed, as it hasn't been supported for some time.</li>
 <li>Several <a href="/en/IndexedDB" title="IndexedDB">IndexedDB</a> internal interfaces have changed to support revised APIs. This shouldn't affect you but is worth noting on the off chance you were doing something unusual.</li>
</ul>

<h2 id="Other_changes_worth_noting">Other changes worth noting</h2>

<ul>
 <li>All binary components on Windows should be built with ASLR (address space layout randomization) support enabled. While this is not <strong>yet</strong> required, it may be in the future, and not enabling it results in a performance penalty.</li>
 <li>A bug in regular expression handling that was introduced in Firefox 7 has been fixed. This can change the result of some regular expressions, so be aware of it.</li>
 <li>You can now <a href="/en/Extensions/Bootstrapped_extensions#Adding_user_interface_with_a_chrome.manifest" title="en/Extensions/Bootstrapped_extensions#Adding_user_interface_with_a_chrome.manifest">dynamically load and unload chrome.manifest files in bootstrapped add-ons</a>.</li>
 <li>The <code>mouseenter</code> and <code>mouseleave</code> events are now supported.</li>
</ul>
